unit Unit1;

interface

uses
  SysUtils, Classes, QForms,
  EasyEditor, EasyEditSource, EasySearchDlg, EasyReplDlg, EasyGoToDlg,
  QControls, QDialogs, QComCtrls, QExtCtrls, QStdCtrls, EasyBox;

const
  EasyEditorDemosCount = 13;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    TreeView1: TTreeView;
    Panel: TPanel;
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    procedure ShowDemoForms;
    procedure ChangeDemo(Value : TPanel);
    { Public declarations }
  end;

TTreeViewItems = array [1..EasyEditorDemosCount] of string;

var
  MainForm: TMainForm;

const
  TreeViewItems : TTreeViewItems = ('Features', 'Gutter\Margin', 'Page Type',
  'Word Wrap\Tabs', 'Background', 'Syntax Parsers', 'EasyEditor Dialogs',
  'EasyEditor Source', 'Products', 'Easy Editor', 'Easy RichEditor',
  'Scheduler', 'Company Info');

implementation

uses
  Unit2;
  
{$R *.xfm}

{---------------------------------------------------}


procedure TMainForm.FormCreate(Sender: TObject);
begin
  frmContainer := TfrmContainer.Create(Application);
  with TreeView1 do
    FullExpand;
end;

{---------------------------------------------------}

procedure TMainForm.ChangeDemo(Value : TPanel);
begin
  with Value do
  begin
    Parent := Panel;
    Align := alClient;
    BringToFront;
  end;
end;

{---------------------------------------------------}

procedure TMainForm.TreeView1Change(Sender: TObject;
  Node: TTreeNode);
begin
   ShowDemoForms;
end;

{---------------------------------------------------}


procedure TMainForm.ShowDemoForms;
var
  j : integer;
  procedure SetNumberOfDemo;
var
  i : integer;
  begin
    for i := 1 to EasyEditorDemosCount do
    begin
      if CompareText(TreeViewItems[i], TreeView1.Selected.Text) = 0 then
      begin
        j := i;
        Exit;
      end
      else j :=1;
    end;
  end;
begin
  SetNumberOfDemo;
  with frmContainer do
  case j of
//    1 : TreeView1.Selected := TreeView1.Items[1];
    2 : ChangeDemo(GutterMarginPanel);
    3 : ChangeDemo(PageTypePanel);
    4 : ChangeDemo(WrapPanel);
    5 : ChangeDemo(BackgroundPanel);
    6 : ChangeDemo(SyntaxParsersPanel);
    7 : ChangeDemo(EasyEditorDialogPanel);
    8 : ChangeDemo(EasyEditorSourcePanel);
    10 : ChangeDemo(pnProject1);
    11 : ChangeDemo(pnProject2);
    12 : ShowMessage('Under Development');
    13 : ChangeDemo(CompanyPanel);
  end;
end;

{---------------------------------------------------}

procedure TMainForm.FormShow(Sender: TObject);
begin
  with TreeView1 do
    Selected := Items[1];
end;

{---------------------------------------------------}

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i : integer;
begin
  for i := Panel.ControlCount - 1 downto 0 do
    Panel.Controls[i].Parent := nil;
end;

end.


 