unit Unit2;

interface

uses
  SysUtils, Classes,
  EasyEditor, EasyBox, EasyEditSource, EasyControls,
  EasyClasses, EasyParser, EasyKeyMap, EasyCustomDlg,
  QDialogs, QGraphics, QExtCtrls, QStdCtrls, QForms, QControls,
  QButtons, QComCtrls, Qt;


const
  LanguagesCount = 35;

type
  TfrmContainer = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    TabSheet8: TTabSheet;
    TabSheet9: TTabSheet;
    TabSheet10: TTabSheet;
    GutterMarginPanel: TPanel;
    Panel2: TPanel;
    gbBreakpointAndBookmarks: TGroupBox;
    SpeedButton1: TSpeedButton;
    SpeedButton12: TSpeedButton;
    gbMargin: TGroupBox;
    lbMarginColor: TLabel;
    lbMarginPosition: TLabel;
    edMarginPosition: TEdit;
    EasyColorBox1: TEasyColorBox;
    gbGutterMargin: TGroupBox;
    lbGutterWidth: TLabel;
    lbGutterColor: TLabel;
    chbLineNumbers: TCheckBox;
    chbLinesOnGutter: TCheckBox;
    chbShowGutter: TCheckBox;
    cbGutterColor: TEasyColorBox;
    edWidth: TEdit;
    chbShowMargin: TCheckBox;
    WrapPanel: TPanel;
    Panel1: TPanel;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    gbWordWrap: TGroupBox;
    chbWordWrap: TCheckBox;
    chbUseTabCharacter: TCheckBox;
    chbWrapAtMargin: TCheckBox;
    chbCursorOnTabs: TCheckBox;
    EasyEdit2: TEasyEdit;
    BackgroundPanel: TPanel;
    Panel4: TPanel;
    gbEdit: TGroupBox;
    lbStyleGutter: TLabel;
    lbBeginColorGutter: TLabel;
    lbEndColorGutter: TLabel;
    cbBackgroundOptions: TComboBox;
    cbBeginColorStyle: TEasyColorBox;
    cbEndColorStyle: TEasyColorBox;
    gbGutter: TGroupBox;
    lbStyleEdit: TLabel;
    lbBeginColorEdit: TLabel;
    lbEndColorEdit: TLabel;
    cbGutterOptions: TComboBox;
    cbBeginColorStyleGutter: TEasyColorBox;
    cbEndColorStyleGutter: TEasyColorBox;
    EasyEdit4: TEasyEdit;
    SyntaxParsersPanel: TPanel;
    EasyEdit3: TEasyEdit;
    lbLanguages: TListBox;
    pnSyntaxParser: TPanel;
    lbLanguage: TLabel;
    lbPress: TLabel;
    lbColorMapping: TLabel;
    cbColorMapping: TComboBox;
    EasyEditorDialogPanel: TPanel;
    Panel5: TPanel;
    btLoad: TButton;
    btSave: TButton;
    btFind: TButton;
    btCustomize: TButton;
    btReplace: TButton;
    btGoTo: TButton;
    EasyEditorSourcePanel: TPanel;
    Panel7: TPanel;
    lbSeveralEditor: TLabel;
    EasyEdit6: TEasyEdit;
    EasyEdit7: TEasyEdit;
    PageTypePanel: TPanel;
    Panel9: TPanel;
    lbPageType: TLabel;
    ComboBox1: TComboBox;
    EasyEdit9: TEasyEdit;
    CompanyPanel: TPanel;
    pnProject1: TPanel;
    Panel10: TPanel;
    Panel11: TPanel;
    Panel12: TPanel;
    EasyEditSource1: TEasyEditSource;
    EasyEditorParser1: TEasyEditorParser;
    EasyEditorParser2: TEasyEditorParser;
    EasyEditSource2: TEasyEditSource;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    EasyEditorParser3: TEasyEditorParser;
    EasyEditSource3: TEasyEditSource;
    EasyEdit1: TEasyEdit;
    EasyEdit5: TEasyEdit;
    Label12: TLabel;
    Label10: TLabel;
    Label13: TLabel;
    Label11: TLabel;
    Panel13: TPanel;
    Label1: TLabel;
    Label8: TLabel;
    Image1: TImage;
    Panel3: TPanel;
    Label14: TLabel;
    Label15: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    Label6: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label30: TLabel;
    Label32: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    TabSheet7: TTabSheet;
    pnProject2: TPanel;
    Panel15: TPanel;
    Label9: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Panel16: TPanel;
    Label26: TLabel;
    Panel17: TPanel;
    Label28: TLabel;
    Label31: TLabel;
    Panel18: TPanel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    procedure chbWordWrapClick(Sender: TObject);
    procedure chbUseTabCharacterClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure chbCursorOnTabsClick(Sender: TObject);
    procedure cbBackgroundOptionsChange(Sender: TObject);
    procedure EasycbBeginColorStyleChange(Sender: TObject);
    procedure EasycbEndColorStyleChange(Sender: TObject);
    procedure btFindClick(Sender: TObject);
    procedure lbLanguagesClick(Sender: TObject);
    procedure btCustomizeClick(Sender: TObject);
    procedure chbLineNumbersClick(Sender: TObject);
    procedure chbLinesOnGutterClick(Sender: TObject);
    procedure chbShowGutterClick(Sender: TObject);
    procedure edWidthEnter(Sender: TObject);
    procedure cbGutterColorChange(Sender: TObject);
    procedure chbShowMarginClick(Sender: TObject);
    procedure edMarginPositionEnter(Sender: TObject);
    procedure EasyColorBox1Change(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton12Click(Sender: TObject);
    procedure chbWrapAtMarginClick(Sender: TObject);
    procedure cbBeginColorStyleChange(Sender: TObject);
    procedure cbEndColorStyleChange(Sender: TObject);
    procedure cbGutterOptionsChange(Sender: TObject);
    procedure btReplaceClick(Sender: TObject);
    procedure btGoToClick(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure cbColorMappingChange(Sender: TObject);
    procedure chbActiveClick(Sender: TObject);
    procedure Label30Click(Sender: TObject);
    procedure Label29Click(Sender: TObject);
    procedure Label31Click(Sender: TObject);
    procedure Label10Click(Sender: TObject);
    procedure Label11Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cbBeginColorStyleGutterChange(Sender: TObject);
    procedure cbEndColorStyleGutterChange(Sender: TObject);
    procedure btLoadClick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure EasyEdit3AutoComplete(Sender: TObject; Strings: TStrings;
      AKey: Char; var AllowPopup: Boolean);
    procedure EasyEdit3DisplayHint(Sender: TObject; var s: String;
      AKey: Char; var AllowPopup: Boolean);
    procedure EasyEdit3BeforeInsertPopup(Sender: TObject; var s: String);
    procedure EasyEdit1WordSpell(Sender: TObject; const s: String;
      var Correct: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TLanguagesTextAndRules = array [1..LanguagesCount] of string;

var
  frmContainer: TfrmContainer;

const
  LanguagesText : TLanguagesTextAndRules = ('aspinhtml.txt', 'assembler.txt', 'awk.txt',
    'c.txt', 'csharp.txt', 'cppbuilder.txt', 'clipper.txt', 'css1.txt', 'css2.txt', 'dfm.txt',
    'fortran.txt', 'foxpro.txt', 'html.txt', 'ini.txt', 'javabuilder.txt', 'jscript.txt',
    'jsinhtml.txt', 'midl.txt', 'modula2.txt', 'batch.txt', 'oberon.txt', 'objectpascal.txt',
   'perl.txt', 'phpinhtml.txt', 'plsql.txt', 'python.txt', 'rc.txt', 'sql_oracle.txt',
   'tcltk.txt', 'shell.txt', 'vbscript.txt', 'vbsinhtml.txt', 'vbasic.txt', 'xml.txt',
   'xml_scripts.txt');

  LanguagesRules : TLanguagesTextAndRules = ('asp(vbs)_html.xs', 'assembler.xs', 'awk_script.xs', 'c.xs',
    'c#.xs', 'c++builder.xs', 'cliper.xs', 'css_lev1.xs', 'css_lev2.xs', 'dfm_files.xs', 'fortran.xs',
    'foxpro.xs', 'html.xs', 'ini_files.xs', 'java.xs', 'java_script.xs', 'javascript_html.xs',
    'microsoft_idl.xs', 'modula2.xs', 'ms_dosbl.xs', 'oberon.xs', 'delphi.xs', 'perl.xs', 'php_in_html.xs',
    'pl_sql.xs', 'python.xs', 'resourse_rs_files.xs', 'sql_oracle.xs', 'tcltk.xs', 'unix_shell.xs',
    'vbs_script.xs', 'vbs_script_html.xs', 'vis_basic.xs', 'xml.xs', 'xml_with_scripts.xs');

implementation
uses
  typinfo;
{$R *.xfm}
const
  sPropStr = '{\rtf{\colortbl\red0\green0\blue0;\red0\green128\blue128;} \cf1 Property \cf0 | %s | \b %s}';

{------------------------------------------------------}

procedure FillStrings(Strings : TStrings; AClass : TClass);
var
  i         : integer;
  Count     : integer;
  RealCount : integer;
  PropInfo  : PPropInfo;
  PropList  : PPropList;
begin
  Count := GetTypeData(AClass.ClassInfo)^.PropCount;
  if Count > 0 then
  begin
    GetMem(PropList, Count * SizeOf(Pointer));
    try
      RealCount := GetPropList(AClass.ClassInfo, tkAny, PropList);
      for I := 0 to RealCount - 1 do
      begin
        PropInfo := PropList^[I];
        Strings.Add(Format(sPropStr, [PropInfo.Name, PropInfo.PropType^.Name]));
      end;
    finally
      FreeMem(PropList, Count * SizeOf(Pointer));
    end;
  end;
end;

{------------------------------------------------------}

procedure JumpToURL(const s: string);
begin
 // ShellExecute(0, nil, PChar(s), nil, nil, SW_SHOW);
end;

{------------------------------------------------------}

procedure TfrmContainer.FormCreate(Sender: TObject);
var
  s : string;
begin
  {$IFDEF LINUX}
  s := ExtractFilePath(ParamStr(0)) + '../' + 'syntax/delphi.xs';
  {$ELSE}
  s := ExtractFilePath(ParamStr(0)) + '..\' + 'syntax\delphi.xs';
  {$ENDIF}
  EasyEditorParser1.Rules.LoadFromFile(s);
  EasyEdit2.WantTabs := True;
  EasyEdit2.WordWrap := chbWordWrap.Checked;
  chbWordWrap.Checked := True;
  cbBeginColorStyle.SelectedColor := EasyEdit4.Background.GradientStartColor;
  cbEndColorStyle.SelectedColor := EasyEdit4.Background.GradientEndColor;
  cbBeginColorStyleGutter.SelectedColor := EasyEdit4.Gutter.Background.GradientStartColor;
  cbEndColorStyleGutter.SelectedColor := EasyEdit4.Gutter.Background.GradientEndColor;
  edWidth.Text := '32';
  edMarginPosition.Text := '70';
  cbBackgroundOptions.ItemIndex := 1;
  {$IFDEF LINUX}
  s := ExtractFilePath(ParamStr(0)) + '../' + 'text/objectpascal.txt';
  {$ELSE}
  s := ExtractFilePath(ParamStr(0)) + '..\' + 'text\objectpascal.txt';
  {$ENDIF}
  EasyEdit1.Lines.LoadFromFile(s);
  EasyEdit2.Lines.LoadFromFile(s);
  EasyEdit3.Lines.LoadFromFile(s);
  EasyEdit4.Lines.LoadFromFile(s);
  EasyEdit5.Lines.LoadFromFile(s);
  EasyEdit6.Lines.LoadFromFile(s);
  EasyEdit7.Lines.LoadFromFile(s);
  EasyEdit9.Lines.LoadFromFile(s);
  lbLanguages.ItemIndex := 0;
  lbLanguages.OnClick(lbLanguages);
  //Table1.Open;
end;

{------------------------------------------------------}

procedure TfrmContainer.EasycbBeginColorStyleChange(Sender: TObject);
begin
  EasyEdit4.Background.GradientStartColor := cbBeginColorStyle.SelectedColor;
end;

{------------------------------------------------------}

procedure TfrmContainer.EasycbEndColorStyleChange(Sender: TObject);
begin
  EasyEdit4.Background.GradientEndColor := cbEndColorStyle.SelectedColor;
end;

{------------------------------------------------------}

procedure TfrmContainer.lbLanguagesClick(Sender: TObject);
var
  FileLanguageText  : string;
  FileLanguageRules : string;
begin
  {$IFDEF LINUX}
  FileLanguageRules := ExtractFilePath(ParamStr(0))+ '../' + 'syntax/' + LanguagesRules[lbLanguages.ItemIndex + 1];
  FileLanguageText := ExtractFilePath(ParamStr(0)) + '../' + 'text/' + LanguagesText[lbLanguages.ItemIndex + 1];
  {$ELSE}
  FileLanguageRules := ExtractFilePath(ParamStr(0))+ '..\' + 'syntax\' + LanguagesRules[lbLanguages.ItemIndex + 1];
  FileLanguageText := ExtractFilePath(ParamStr(0)) + '..\' + 'text\' + LanguagesText[lbLanguages.ItemIndex + 1];
  {$ENDIF}
  EasyEditorParser3.Rules.LoadFromFile(FileLanguageRules);
  EasyEdit3.Lines.LoadFromFile(FileLanguageText);
end;

{------------------------------------------------------}

procedure TfrmContainer.btFindClick(Sender: TObject);
begin
  EasyEdit5.ExecuteDialog(cFind);
end;

{------------------------------------------------------}

procedure TfrmContainer.btReplaceClick(Sender: TObject);
begin
  EasyEdit5.ExecuteDialog(cReplace);
end;

{------------------------------------------------------}

procedure TfrmContainer.btGoToClick(Sender: TObject);
begin
  EasyEdit5.ExecuteDialog(cGotoLine);
end;

{------------------------------------------------------}

procedure TfrmContainer.btCustomizeClick(Sender: TObject);
begin
  ShowEditorSettings;
end;

{------------------------------------------------------}

procedure TfrmContainer.chbLineNumbersClick(Sender: TObject);
begin
  with EasyEdit1.LineNumbers do
    Visible := chbLineNumbers.Checked;
end;

{------------------------------------------------------}

procedure TfrmContainer.chbLinesOnGutterClick(Sender: TObject);
begin
  with EasyEdit1.LineNumbers do
    if chbLinesOnGutter.Checked and chbShowGutter.Checked then
      Options := Options + [lnPaintOnGutter]
    else
      Options := Options - [lnPaintOnGutter];
end;

{------------------------------------------------------}

procedure TfrmContainer.chbShowGutterClick(Sender: TObject);
begin
  with EasyEdit1 do
  try
    if chbShowGutter.Checked then
    begin
      Options := Options + [eoPaintGutter];
      Gutter.Width := StrToInt(edWidth.Text);
    end
    else
      Options := Options - [eoPaintGutter];
  except
  end;
end;

{------------------------------------------------------}

procedure TfrmContainer.edWidthEnter(Sender: TObject);
begin
  with EasyEdit1.Gutter do
    if chbShowGutter.Checked then
      Width := StrToInt(edWidth.Text);
end;

{------------------------------------------------------}

procedure TfrmContainer.cbGutterColorChange(Sender: TObject);
begin
  with EasyEdit1.Gutter.Brush do
    if chbShowGutter.Checked then
      Color := cbGutterColor.SelectedColor;
end;

{------------------------------------------------------}

procedure TfrmContainer.chbShowMarginClick(Sender: TObject);
begin
  with EasyEdit1 do
    if chbShowMargin.Checked then
    begin
      Options := Options + [eoPaintMargin];
      Margin.Pen.Color := EasyColorBox1.SelectedColor;
    end
    else
      Options := Options - [eoPaintMargin];
end;

{------------------------------------------------------}

procedure TfrmContainer.edMarginPositionEnter(Sender: TObject);
begin
  with EasyEdit1.Margin do
    if chbShowMargin.Checked then
      Position := StrToInt(edMarginPosition.Text);
end;

{------------------------------------------------------}

procedure TfrmContainer.EasyColorBox1Change(Sender: TObject);
begin
  with EasyEdit1.Margin.Pen do
    if chbShowMargin.Checked then
      Color := EasyColorBox1.SelectedColor;
end;

{------------------------------------------------------}

procedure TfrmContainer.SpeedButton1Click(Sender: TObject);
begin
  EasyEdit1.ToggleBookMark(1)
end;

{------------------------------------------------------}

procedure TfrmContainer.SpeedButton12Click(Sender: TObject);
begin
  with EasyEdit1.EditSource do
    ToggleLineStyle(CurrentPosition.Y, 0);
end;

{------------------------------------------------------}

procedure TfrmContainer.chbWordWrapClick(Sender: TObject);
begin
   EasyEdit2.WordWrap := chbWordWrap.Checked;
end;

{------------------------------------------------------}

procedure TfrmContainer.chbWrapAtMarginClick(Sender: TObject);
begin
  with EasyEdit2 do
    if chbWrapAtMargin.Checked and chbWordWrap.Checked then
      Options := Options +[eoBreakWordsAtMargin]
    else
      Options := Options -[eoBreakWordsAtMargin];
end;

{------------------------------------------------------}

procedure TfrmContainer.chbUseTabCharacterClick(Sender: TObject);
begin
  with EasyEdit2.EditSource do
    if chbUseTabCharacter.Checked then
      Options := Options + [srUseTab]
    else
      Options := Options - [srUseTab];
end;

{------------------------------------------------------}

procedure TfrmContainer.chbCursorOnTabsClick(Sender: TObject);
begin
  with EasyEdit2.EditSource do
    if chbUseTabCharacter.Checked then
      Options := Options + [srCursorThroughTabs]
    else
      Options := Options - [srCursorThroughTabs];
end;

{------------------------------------------------------}

procedure TfrmContainer.cbBackgroundOptionsChange(Sender: TObject);
begin
  with EasyEdit4.Background do
    Option := TEasyBackgroundOption(cbBackgroundOptions.ItemIndex);
end;

{------------------------------------------------------}

procedure TfrmContainer.cbBeginColorStyleChange(Sender: TObject);
begin
  with EasyEdit4.Background do
    GradientStartColor := cbBeginColorStyle.SelectedColor;
end;

{------------------------------------------------------}

procedure TfrmContainer.cbEndColorStyleChange(Sender: TObject);
begin
  with EasyEdit4.Background do
    GradientEndColor := cbEndColorStyle.SelectedColor;
end;

{------------------------------------------------------}

procedure TfrmContainer.cbGutterOptionsChange(Sender: TObject);
begin
  with EasyEdit4.Gutter.Background do
    Option := TEasyBackgroundOption(cbGutterOptions.ItemIndex);
end;

{------------------------------------------------------}

procedure TfrmContainer.ComboBox1Change(Sender: TObject);
begin
  case ComboBox1.ItemIndex of
    0 : EasyEdit9.PageType := ptNormal;
    1 : begin
          EasyEdit9.PageType := ptPageBreaks;
        end;
    2 : begin
          EasyEdit9.PageType := ptPageLayout;
        end;
   end;
end;

{------------------------------------------------------}

procedure TfrmContainer.cbColorMappingChange(Sender: TObject);
begin
  case cbColorMapping.ItemIndex of
    0 : EasyEditorParser3.ColorMapping := cmClassic;
    1 : EasyEditorParser3.ColorMapping := cmDefault;
    2 : EasyEditorParser3.ColorMapping := cmOcean;
    3 : EasyEditorParser3.ColorMapping := cmTwilight;
  end;
end;

{------------------------------------------------------}

procedure TfrmContainer.chbActiveClick(Sender: TObject);
begin
  //Table1.Active := chbActive.Checked;
end;

{------------------------------------------------------}

procedure TfrmContainer.Label30Click(Sender: TObject);
begin
  JumpToURL('WWW.Soford.com/download.html');
end;

{------------------------------------------------------}

procedure TfrmContainer.Label29Click(Sender: TObject);
begin
  JumpToURL('www.Soford.com');
end;

{------------------------------------------------------}

procedure TfrmContainer.Label31Click(Sender: TObject);
begin
  JumpToURL('www.Soford.com');
end;

{------------------------------------------------------}

procedure TfrmContainer.Label10Click(Sender: TObject);
begin
  JumpToURL(Label10.Caption);
end;

{------------------------------------------------------}

procedure TfrmContainer.Label11Click(Sender: TObject);
begin
    JumpToURL('mailto://'+Label11.Caption);
end;

{------------------------------------------------------}

procedure TfrmContainer.FormDestroy(Sender: TObject);
begin
  EasyEdit7.EditSource := nil;
  EasyEdit6.EditSource := nil;
end;

{------------------------------------------------------}

procedure TfrmContainer.cbBeginColorStyleGutterChange(Sender: TObject);
begin
  with EasyEdit4.Gutter.Background do
    GradientStartColor := cbBeginColorStyleGutter.SelectedColor;
end;

{------------------------------------------------------}

procedure TfrmContainer.cbEndColorStyleGutterChange(Sender: TObject);
begin
  with EasyEdit4.Gutter.Background do
    GradientEndColor := cbEndColorStyleGutter.SelectedColor;
end;

{------------------------------------------------------}

procedure TfrmContainer.btLoadClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
    EasyEdit5.Lines.LoadFromFile(OpenDialog1.FileName);
end;

{------------------------------------------------------}

procedure TfrmContainer.btSaveClick(Sender: TObject);
begin
  if SaveDialog1.Execute then
    EasyEdit5.Lines.SaveToFile(SaveDialog1.FileName);
end;
 procedure TfrmContainer.EasyEdit3AutoComplete(Sender: TObject;
  Strings: TStrings; AKey: Char; var AllowPopup: Boolean);
begin
  AllowPopup := (AKey = '.');
  if AllowPopup then
    FillStrings(Strings, TWinControl);

end;
{------------------------------------------------------}

procedure TfrmContainer.EasyEdit3DisplayHint(Sender: TObject;
  var s: String; AKey: Char; var AllowPopup: Boolean);
begin
  AllowPopup := AKey = '=';
  if AllowPopup then
    s := Format(sPropStr, ['Sample prop', 'sample type']);
end;

procedure TfrmContainer.EasyEdit3BeforeInsertPopup(Sender: TObject;
  var s: String);
var
  P : integer;
begin
  P := Pos('|', s);
  if P <> 0 then
    Delete(s, 1, P);
  P := Pos('|', s);
  if P <> 0 then
    Delete(s, P, MaxInt);
  s := Trim(s);
end;

procedure TfrmContainer.EasyEdit1WordSpell(Sender: TObject;
  const s: String; var Correct: Boolean);
begin
  Correct := false;
end;


end.
