{*****************************************************}
{                                                     }
{ GotoLine dialog                                     }
{                                                     }
{ Copyright(c) 2001 Soford - Software For Developers  }
{ http://www.soford.com                               }
{ e-mail: contact@soford.com                          }
{                                                     }
{*****************************************************}

unit EasyGoToDlg;

interface
{$I Easy.inc}
uses
  {$IFNDEF EASY_CLX}
  Windows, Messages, Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls,
  {$ELSE}
  QForms, QControls, QStdCtrls, QExtCtrls, 
  {$ENDIF}
  SysUtils, Classes,
  EasyControls, EasySettings, EasyUtils, EasyBox;

type
  TFrmGoToDlg = class(TForm)
    btOk: TButton;
    btCancel: TButton;
    btHelp: TButton;
    lbEnterNewLineNamber: TLabel;
    cbNewLineNumber: TEasyHistoryEditor;
    procedure FormCreate(Sender: TObject);
    procedure btOkClick(Sender: TObject);
  private
    { Private declarations }
  public
    procedure LoadSettings; virtual;
    procedure SaveSettings; virtual;
    { Public declarations }
  end;

var
  FrmGoToDlg: TFrmGoToDlg;

implementation

{$IFNDEF EASY_CLX}
{$R *.DFM}
{$ELSE}
{$R *.xfm}
{$ENDIF}

{--------------------------------------------}

procedure TFrmGoToDlg.LoadSettings;
begin
  cbNewLineNumber.Text := IntToStr(SearchSettings.GotoLineNumber);
end;

{--------------------------------------------}

procedure TFrmGoToDlg.SaveSettings;
begin
  SearchSettings.GoToLineNumber := StrToInt(cbNewLineNumber.Text);
end;

{--------------------------------------------}

procedure TFrmGoToDlg.FormCreate(Sender: TObject);
begin
  cbNewLineNumber.FileName := AddSlash(GetTempDir) + 'dialogs.ini';
  cbNewLineNumber.LoadHistory;
  LoadSettings;
end;

{--------------------------------------------}

procedure TFrmGoToDlg.btOkClick(Sender: TObject);
begin
  SaveSettings;
end;

{--------------------------------------------}

initialization
  GlobalGoToLineDialogClass := TFrmGoToDlg;
end.
