{*****************************************************}
{                                                     }
{ Replace dialog                                      }
{                                                     }
{ Copyright(c) 2001 Soford - Software For Developers  }
{ http://www.soford.com                               }
{ e-mail: contact@soford.com                          }
{                                                     }
{*****************************************************}

unit EasyReplDlg;

interface
{$I Easy.inc}
uses
  {$IFNDEF EASY_CLX}
  Windows, Messages, Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls,
  {$ELSE}
  QForms, QControls, QStdCtrls, QExtCtrls,
  {$ENDIF}
  SysUtils, Classes,
  EasySearchDlg, EasyControls, EasySettings, EasyBox;

type
  TFrmReplDlg = class(TFrmFindDlg)
    lbReplaceWith: TLabel;
    chbPromptOnReplace: TCheckBox;
    btReplaceAll: TButton;
    cbReplaceWith: TEasyHistoryEditor;
    procedure btOKClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    procedure LoadSettings; override;
    procedure SaveSettings; override;
    { Public declarations }
  end;

var
  FrmReplDlg: TFrmReplDlg;

implementation
{$IFNDEF EASY_CLX}
{$R *.DFM}
{$ELSE}
{$R *.xfm}
{$ENDIF}

{--------------------------------------------}

procedure TFrmReplDlg.LoadSettings;
begin
  inherited;
  with SearchSettings do
  begin
    cbReplaceWith.Text := ReplaceWith;
    chbPromptOnReplace.Checked := PromptOnReplace;
  end;
end;

{--------------------------------------------}

procedure TFrmReplDlg.SaveSettings;
begin
  inherited;
  with SearchSettings do
  begin
    ReplaceWith := cbReplaceWith.Text;
    PromptOnReplace := chbPromptOnReplace.Checked;
  end;
end;

{--------------------------------------------}

procedure TFrmReplDlg.btOKClick(Sender: TObject);
begin
  inherited;
  SearchSettings.ReplaceAll := Sender = btReplaceAll;
end;

{--------------------------------------------}

procedure TFrmReplDlg.FormCreate(Sender: TObject);
begin
  inherited;
  cbReplaceWith.TabOrder := 1;
  cbReplaceWith.FileName := cbTextToFind.FileName; 
end;

initialization
  GlobalReplaceDialogClass := TFrmReplDlg;

end.
